""" Some grabbag tools """

import pymbolic.primitives as prim


def get_pymbolic_basename(expr):
    assert isinstance(expr, prim.Expression), "Type: {}, expr: {}".format(type(expr), expr)

    if isinstance(expr, prim.Variable):
        return expr.name

    if isinstance(expr, prim.Subscript):
        return get_pymbolic_basename(expr.aggregate)

    raise NotImplementedError("Cannot determine basename of {}".format(expr))


def get_pymbolic_indices(expr):
    if not isinstance(expr, prim.Subscript):
        return ()

    def ind(i):
        if isinstance(i, int):
            return i
        return get_pymbolic_basename(i)

    if not isinstance(expr.index, tuple):
        return (ind(expr.index),)

    return tuple(ind(i) for i in expr.index)


def maybe_wrap_subscript(expr, indices):
    if indices is None:
        indices = ()
    if not isinstance(indices, tuple):
        indices = (indices,)
    if indices:
        if isinstance(expr, prim.Subscript):
            return prim.Subscript(expr.aggregate, expr.index + indices)
        else:
            return prim.Subscript(expr, indices)
    else:
        return expr
